Loading...
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
65 -lutil ${1}
66 rm -f linux
67 fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74 info KSYM ${2}
75 local kallsymopt;
76
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
79 fi
80
81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82 kallsymopt="${kallsymopt} --all-symbols"
83 fi
84
85 if [ -n "${CONFIG_ARM}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
87 fi
88
89 if [ -n "${CONFIG_X86_64}" ]; then
90 kallsymopt="${kallsymopt} --absolute-percpu"
91 fi
92
93 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
94 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
95
96 ${NM} -n ${1} | \
97 scripts/kallsyms ${kallsymopt} | \
98 ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
99}
100
101# Create map file with all symbols from ${1}
102# See mksymap for additional details
103mksysmap()
104{
105 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
106}
107
108sortextable()
109{
110 ${objtree}/scripts/sortextable ${1}
111}
112
113# Delete output files in case of error
114trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
115cleanup()
116{
117 rm -f .old_version
118 rm -f .tmp_System.map
119 rm -f .tmp_kallsyms*
120 rm -f .tmp_version
121 rm -f .tmp_vmlinux*
122 rm -f System.map
123 rm -f vmlinux
124 rm -f vmlinux.o
125}
126
127#
128#
129# Use "make V=1" to debug this script
130case "${KBUILD_VERBOSE}" in
131*1*)
132 set -x
133 ;;
134esac
135
136if [ "$1" = "clean" ]; then
137 cleanup
138 exit 0
139fi
140
141# We need access to CONFIG_ symbols
142case "${KCONFIG_CONFIG}" in
143*/*)
144 . "${KCONFIG_CONFIG}"
145 ;;
146*)
147 # Force using a file from the current directory
148 . "./${KCONFIG_CONFIG}"
149esac
150
151#link vmlinux.o
152info LD vmlinux.o
153modpost_link vmlinux.o
154
155# modpost vmlinux.o to check for section mismatches
156${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
157
158# Update version
159info GEN .version
160if [ ! -r .version ]; then
161 rm -f .version;
162 echo 1 >.version;
163else
164 mv .version .old_version;
165 expr 0$(cat .old_version) + 1 >.version;
166fi;
167
168# final build of init/
169${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
170
171kallsymso=""
172kallsyms_vmlinux=""
173if [ -n "${CONFIG_KALLSYMS}" ]; then
174
175 # kallsyms support
176 # Generate section listing all symbols and add it into vmlinux
177 # It's a three step process:
178 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
179 # but __kallsyms is empty.
180 # Running kallsyms on that gives us .tmp_kallsyms1.o with
181 # the right size
182 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
183 # the right size, but due to the added section, some
184 # addresses have shifted.
185 # From here, we generate a correct .tmp_kallsyms2.o
186 # 2a) We may use an extra pass as this has been necessary to
187 # woraround some alignment related bugs.
188 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
189 # 3) The correct ${kallsymso} is linked into the final vmlinux.
190 #
191 # a) Verify that the System.map from vmlinux matches the map from
192 # ${kallsymso}.
193
194 kallsymso=.tmp_kallsyms2.o
195 kallsyms_vmlinux=.tmp_vmlinux2
196
197 # step 1
198 vmlinux_link "" .tmp_vmlinux1
199 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
200
201 # step 2
202 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
203 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
204
205 # step 2a
206 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
207 kallsymso=.tmp_kallsyms3.o
208 kallsyms_vmlinux=.tmp_vmlinux3
209
210 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
211
212 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
213 fi
214fi
215
216info LD vmlinux
217vmlinux_link "${kallsymso}" vmlinux
218
219if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
220 info SORTEX vmlinux
221 sortextable vmlinux
222fi
223
224info SYSMAP System.map
225mksysmap vmlinux System.map
226
227# step a (see comment above)
228if [ -n "${CONFIG_KALLSYMS}" ]; then
229 mksysmap ${kallsyms_vmlinux} .tmp_System.map
230
231 if ! cmp -s System.map .tmp_System.map; then
232 echo >&2 Inconsistent kallsyms data
233 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
234 cleanup
235 exit 1
236 fi
237fi
238
239# We made a new kernel - delete old version file
240rm -f .old_version
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12# ^
13# |
14# +--< vmlinux.a
15# |
16# +--< $(KBUILD_VMLINUX_LIBS)
17# | +--< lib/lib.a + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
35is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
37}
38
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
43 printf " %-7s %s\n" "${1}" "${2}"
44}
45
46# Link of vmlinux
47# ${1} - output file
48vmlinux_link()
49{
50 local output=${1}
51 local objs
52 local libs
53 local ld
54 local ldflags
55 local ldlibs
56
57 info LD ${output}
58
59 # skip output file argument
60 shift
61
62 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
63 # Use vmlinux.o instead of performing the slow LTO link again.
64 objs=vmlinux.o
65 libs=
66 else
67 objs=vmlinux.a
68 libs="${KBUILD_VMLINUX_LIBS}"
69 fi
70
71 if is_enabled CONFIG_GENERIC_BUILTIN_DTB; then
72 objs="${objs} .builtin-dtbs.o"
73 fi
74
75 if is_enabled CONFIG_MODULES; then
76 objs="${objs} .vmlinux.export.o"
77 fi
78
79 objs="${objs} init/version-timestamp.o"
80
81 if [ "${SRCARCH}" = "um" ]; then
82 wl=-Wl,
83 ld="${CC}"
84 ldflags="${CFLAGS_vmlinux}"
85 ldlibs="-lutil -lrt -lpthread"
86 else
87 wl=
88 ld="${LD}"
89 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
90 ldlibs=
91 fi
92
93 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
94
95 # The kallsyms linking does not need debug symbols included.
96 if [ -n "${strip_debug}" ] ; then
97 ldflags="${ldflags} ${wl}--strip-debug"
98 fi
99
100 if is_enabled CONFIG_VMLINUX_MAP; then
101 ldflags="${ldflags} ${wl}-Map=${output}.map"
102 fi
103
104 ${ld} ${ldflags} -o ${output} \
105 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
106 ${wl}--start-group ${libs} ${wl}--end-group \
107 ${kallsymso} ${btf_vmlinux_bin_o} ${arch_vmlinux_o} ${ldlibs}
108}
109
110# generate .BTF typeinfo from DWARF debuginfo
111# ${1} - vmlinux image
112gen_btf()
113{
114 local btf_data=${1}.btf.o
115
116 info BTF "${btf_data}"
117 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
118
119 # Create ${btf_data} which contains just .BTF section but no symbols. Add
120 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
121 # deletes all symbols including __start_BTF and __stop_BTF, which will
122 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
123 # objcopy warnings: "empty loadable segment detected at ..."
124 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
125 --strip-all ${1} "${btf_data}" 2>/dev/null
126 # Change e_type to ET_REL so that it can be used to link final vmlinux.
127 # GNU ld 2.35+ and lld do not allow an ET_EXEC input.
128 if is_enabled CONFIG_CPU_BIG_ENDIAN; then
129 et_rel='\0\1'
130 else
131 et_rel='\1\0'
132 fi
133 printf "${et_rel}" | dd of="${btf_data}" conv=notrunc bs=1 seek=16 status=none
134
135 btf_vmlinux_bin_o=${btf_data}
136}
137
138# Create ${2}.o file with all symbols from the ${1} object file
139kallsyms()
140{
141 local kallsymopt;
142
143 if is_enabled CONFIG_KALLSYMS_ALL; then
144 kallsymopt="${kallsymopt} --all-symbols"
145 fi
146
147 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
148 kallsymopt="${kallsymopt} --absolute-percpu"
149 fi
150
151 info KSYMS "${2}.S"
152 scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
153
154 info AS "${2}.o"
155 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
156 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
157
158 kallsymso=${2}.o
159}
160
161# Perform kallsyms for the given temporary vmlinux.
162sysmap_and_kallsyms()
163{
164 mksysmap "${1}" "${1}.syms"
165 kallsyms "${1}.syms" "${1}.kallsyms"
166
167 kallsyms_sysmap=${1}.syms
168}
169
170# Create map file with all symbols from ${1}
171# See mksymap for additional details
172mksysmap()
173{
174 info NM ${2}
175 ${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
176}
177
178sorttable()
179{
180 ${objtree}/scripts/sorttable ${1}
181}
182
183cleanup()
184{
185 rm -f .btf.*
186 rm -f System.map
187 rm -f vmlinux
188 rm -f vmlinux.map
189}
190
191# Use "make V=1" to debug this script
192case "${KBUILD_VERBOSE}" in
193*1*)
194 set -x
195 ;;
196esac
197
198if [ "$1" = "clean" ]; then
199 cleanup
200 exit 0
201fi
202
203${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
204
205arch_vmlinux_o=
206if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
207 arch_vmlinux_o=arch/${SRCARCH}/tools/vmlinux.arch.o
208fi
209
210btf_vmlinux_bin_o=
211kallsymso=
212strip_debug=
213
214if is_enabled CONFIG_KALLSYMS; then
215 true > .tmp_vmlinux0.syms
216 kallsyms .tmp_vmlinux0.syms .tmp_vmlinux0.kallsyms
217fi
218
219if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
220
221 # The kallsyms linking does not need debug symbols, but the BTF does.
222 if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
223 strip_debug=1
224 fi
225
226 vmlinux_link .tmp_vmlinux1
227fi
228
229if is_enabled CONFIG_DEBUG_INFO_BTF; then
230 if ! gen_btf .tmp_vmlinux1; then
231 echo >&2 "Failed to generate BTF for vmlinux"
232 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
233 exit 1
234 fi
235fi
236
237if is_enabled CONFIG_KALLSYMS; then
238
239 # kallsyms support
240 # Generate section listing all symbols and add it into vmlinux
241 # It's a four step process:
242 # 0) Generate a dummy __kallsyms with empty symbol list.
243 # 1) Link .tmp_vmlinux1.kallsyms so it has all symbols and sections,
244 # with a dummy __kallsyms.
245 # Running kallsyms on that gives us .tmp_vmlinux1.kallsyms.o with
246 # the right size
247 # 2) Link .tmp_vmlinux2.kallsyms so it now has a __kallsyms section of
248 # the right size, but due to the added section, some
249 # addresses have shifted.
250 # From here, we generate a correct .tmp_vmlinux2.kallsyms.o
251 # 3) That link may have expanded the kernel image enough that
252 # more linker branch stubs / trampolines had to be added, which
253 # introduces new names, which further expands kallsyms. Do another
254 # pass if that is the case. In theory it's possible this results
255 # in even more stubs, but unlikely.
256 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
257 # other bugs.
258 # 4) The correct ${kallsymso} is linked into the final vmlinux.
259 #
260 # a) Verify that the System.map from vmlinux matches the map from
261 # ${kallsymso}.
262
263 # The kallsyms linking does not need debug symbols included.
264 strip_debug=1
265
266 sysmap_and_kallsyms .tmp_vmlinux1
267 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
268
269 vmlinux_link .tmp_vmlinux2
270 sysmap_and_kallsyms .tmp_vmlinux2
271 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
272
273 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
274 vmlinux_link .tmp_vmlinux3
275 sysmap_and_kallsyms .tmp_vmlinux3
276 fi
277fi
278
279strip_debug=
280
281vmlinux_link vmlinux
282
283# fill in BTF IDs
284if is_enabled CONFIG_DEBUG_INFO_BTF; then
285 info BTFIDS vmlinux
286 ${RESOLVE_BTFIDS} vmlinux
287fi
288
289mksysmap vmlinux System.map
290
291if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
292 info SORTTAB vmlinux
293 if ! sorttable vmlinux; then
294 echo >&2 Failed to sort kernel tables
295 exit 1
296 fi
297fi
298
299# step a (see comment above)
300if is_enabled CONFIG_KALLSYMS; then
301 if ! cmp -s System.map "${kallsyms_sysmap}"; then
302 echo >&2 Inconsistent kallsyms data
303 echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
304 exit 1
305 fi
306fi
307
308# For fixdep
309echo "vmlinux: $0" > .vmlinux.d